Alerts triage
===

This application assists SREs alerts triagers. Alerts are sorted by a combination of priority and age, thus the ones in need of triaging appear first. Users can create tasks for alerts they are triaging; the _properties_ (projects, priority, etc) of the new task can be decided based on the alert itself, via _routing_. Other properties (title, description) are set via _templates_.

Getting started
---

You will need a _golang_ runtime installed (`golang-go` package on Debian) and working. Then:

```
go build
./alerts-triage -config config.yml
```

Point your browser to http://localhost:3000/triage for a demo version. You will be presented with a list of alerts in need of triage. By default alerts newer than two weeks will not be displayed.


Routing
---

Task routes are defined by `phabricator_routes` and resemble Alertmanager's own
routing, the mayor difference being there are no sub-routes.

For each route, its `matchers` will be used on all alerts to determine the task's properties, specifically:

* `projects` is a list of projects for the route. These projects will be _appended_ together.
* `priority` is a string with the task priority. Previously set priority will be overriden.
* `continue` indicates whether to continue with routing if this route has matched.

The `matchers` syntax and semantics are the same as [alertmanager `matchers`](https://prometheus.io/docs/alerting/latest/configuration/#matcher).

Templates
---

A task's title and description are generated by the templates found in `templates/phabricator/` directory. The `templates` directory is embedded in the binary (`embed.go`).
